# Configuring Sourcegraph

This page documents how to configure a Sourcegraph instance. For deployment configuration, please refer to the [relevant installation guide](../install/index.md).

- [Site configuration](site_config.md)
- [Code host configuration](../external_service/index.md) (GitHub, GitLab, and the [Nginx HTTP server](../http_https_configuration.md).)
- [Search configuration](../search.md)
- [Configuring Authorization and Authentication](./authorization_and_authentication.md)
- [Batch Changes configuration](batch_changes.md)

## Common tasks

- [Add Git repositories from your code host](../repo/add.md)
- [Add user authentication providers (SSO)](../auth/index.md)
- [Configure search scopes](../../code_search/how-to/scopes.md)
- [Integrate with Phabricator](../../integration/phabricator.md)
- [Add organizations](../organizations.md)
- [Set up HTTPS](../http_https_configuration.md)
- [Use a custom domain](../url.md)
- [Update Sourcegraph](../updates/index.md)
- [Using external services (PostgreSQL, Redis, S3/GCS)](../external_services/index.md)
- [PostgreSQL Config](./postgres-conf.md)

## Advanced tasks

- [Loading configuration via the file system](advanced_config_file.md)
- [Restore postgres database from snapshot](restore/index.md)
- [Enabling database encryption for sensitive data](encryption.md)
