# Getting started

Have a look around, our code is on [GitHub](https://sourcegraph.com/github.com/sourcegraph/sourcegraph).

## Quickstart

- [Quickstart](quickstart.md)

## Troubleshooting

### Local development

- [DEPRECATED: Quickstart without `sg`](deprecated_quickstart.md)
- [How to debug live code](../how-to/debug_live_code.md)
- [Set up local development with Zoekt and Sourcegraph](../how-to/zoekt_local_dev.md)
- [Ignoring editor config files in Git](../how-to/ignoring_editor_config_files.md)
- [Use `golangci-lint`](../how-to/use-golangci-lint.md)
- [Set up local development with M1 mac](../how-to/m1_mac_local_dev.md)

## [Troubleshooting](../how-to/troubleshooting_local_development.md)

- [Problems with node_modules or Javascript packages](../how-to/troubleshooting_local_development.md#problems-with-nodemodules-or-javascript-packages)
- [dial tcp 127.0.0.1:3090: connect: connection refused](../how-to/troubleshooting_local_development.md#dial-tcp-1270013090-connect-connection-refused)
- [Database migration failures](../how-to/troubleshooting_local_development.md#database-migration-failures)
- [Internal Server Error](../how-to/troubleshooting_local_development.md#internal-server-error)
- [Increase maximum available file descriptors.](../how-to/troubleshooting_local_development.md#increase-maximum-available-file-descriptors)
- [Caddy 2 certificate problems](../how-to/troubleshooting_local_development.md#caddy-2-certificate-problems)
- [Running out of disk space](../how-to/troubleshooting_local_development.md#running-out-of-disk-space)
- [Certificate expiry](../how-to/troubleshooting_local_development.md#certificate-expiry)
- [CPU/RAM/bandwidth/battery usage](../how-to/troubleshooting_local_development.md#cpurambandwidthbattery-usage)
