package dbstore

import "github.com/cockroachdb/errors"

// ErrNotTransactable occurs when Transact is called on a store whose underlying
// store handle does not support beginning a transaction.
var ErrNotTransactable = errors.New("store: not transactable")

// ErrNoTransaction occurs when Savepoint or RollbackToSavepoint is called outside of a transaction.
var ErrNoTransaction = errors.New("store: not in a transaction")

// ErrDequeueTransaction occurs when Dequeue is called from inside a transaction.
var ErrDequeueTransaction = errors.New("unexpected transaction")

// ErrDequeueRace occurs when an upload selected for dequeue has been locked by another worker.
var ErrDequeueRace = errors.New("dequeue race")

// ErrNoSavepoint occurs when there is no savepont to rollback to.
var ErrNoSavepoint = errors.New("no savepoint defined")

// ErrIllegalLimit occurs when a limit is not strictly positive.
var ErrIllegalLimit = errors.New("illegal limit")
