### Plan

#### [Support new and existing deployments](https://github.com/orgs/sourcegraph/projects/74)

This is an ongoing expense, we anticipate this taking no more than 10d of work spread across the entire team.

#### Support Security in deploying a log analysis tool

Security is planning to deploy a centralized logging and analysis system and will require our assistance to setup and review this new infrastructure.

#### [Implement 2+ sourcegraph.com services using dhall](https://github.com/orgs/sourcegraph/projects/71)

`sourcegraph.com` sees the highest amount of Kubernetes changes out of all of our deployments + `deploy-sourcegraph`. Scoping a single component limits the customizations that we need to implement and allows for easier onboarding other engineers.

- @ggilmore 
- @uwedeportivo
- @slimsag 

#### [Releases are created in a single day](https://github.com/orgs/sourcegraph/projects/90)

We have a goal of reducing the time it takes to create releases, and this current several-day system has encouraged us to view releases as “baked” rather than “snapshots of the main branch”, leading to situations where main is broken and we have to retrospectively fix it or adding last minute features.

- @slimsag 
- @davejrt 
- @uwedeportivo 
- @bobheadxi 

#### [Split infrastructure into separate GCP projects](https://github.com/orgs/sourcegraph/projects/92)

GCP utilizes project wide roles and permissions, to ensure resources are isolated from each other and reduce the blast radius of changes, we should split resources into separate projects. Additionally, this will grant us more insight into our infrastructure costs and will become more important as we grow and expand it.

- @pecigonzalo 

### Availability

Period is from **September 20th** to **October 19th (21 working days)**. Please write the days you won't be working and the number of working days for the period.

- **Gonza**: 19d (23rd Sept and TBD)

### Tracked issues

<!-- BEGIN WORK -->
<!-- BEGIN ASSIGNEE:  -->
@unassigned: __5.00d__


Completed: __5.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253  __5.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250  __5.00d__
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675  __5.00d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990  __5.00d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: bobheadxi -->
@bobheadxi: __8.50d__


Completed: __8.50d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253  __8.50d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250  __8.50d__
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/12836  __1.00d__   🏳️ [3.20](https://github.com/sourcegraph/sourcegraph/milestone/45)
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675  __8.50d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990  __8.50d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: davejrt -->
@davejrt


Completed
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253 
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250 
- [x] (🏁 437 days ago) https://github.com/sourcegraph/sourcegraph/issues/11954    🏳️ [3.19](https://github.com/sourcegraph/sourcegraph/milestone/44)
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/12836    🏳️ [3.20](https://github.com/sourcegraph/sourcegraph/milestone/45)
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 367 days ago) https://github.com/sourcegraph/sourcegraph/issues/14408    🏳️ [Dist: 2020.10.20](https://github.com/sourcegraph/sourcegraph/milestone/56)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990 
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: daxmc99 -->
@daxmc99: __1.00d__


Completed: __1.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253  __1.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250  __1.00d__
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675  __1.00d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 367 days ago) https://github.com/sourcegraph/sourcegraph/issues/14408  __1.00d__   🏳️ [Dist: 2020.10.20](https://github.com/sourcegraph/sourcegraph/milestone/56)
- [x] (🏁 340 days ago) https://github.com/sourcegraph/sourcegraph/issues/15710  __1.00d__   🏳️ [Dist: 2020.11.16](https://github.com/sourcegraph/sourcegraph/milestone/61)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990  __1.00d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: ggilmore -->
@ggilmore


Completed
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253 
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250 
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/12836    🏳️ [3.20](https://github.com/sourcegraph/sourcegraph/milestone/45)
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 367 days ago) https://github.com/sourcegraph/sourcegraph/issues/14408    🏳️ [Dist: 2020.10.20](https://github.com/sourcegraph/sourcegraph/milestone/56)
- [x] (🏁 340 days ago) https://github.com/sourcegraph/sourcegraph/issues/15710    🏳️ [Dist: 2020.11.16](https://github.com/sourcegraph/sourcegraph/milestone/61)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990 
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: pecigonzalo -->
@pecigonzalo: __15.00d__


Completed: __15.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253  __15.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250  __15.00d__
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/12836  __1.00d__   🏳️ [3.20](https://github.com/sourcegraph/sourcegraph/milestone/45)
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675  __15.00d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 367 days ago) https://github.com/sourcegraph/sourcegraph/issues/14408    🏳️ [Dist: 2020.10.20](https://github.com/sourcegraph/sourcegraph/milestone/56)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990  __15.00d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: slimsag -->
@slimsag: __14.50d__


Completed: __14.50d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253  __14.50d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250  __14.50d__
- [x] (🏁 437 days ago) https://github.com/sourcegraph/sourcegraph/issues/11954    🏳️ [3.19](https://github.com/sourcegraph/sourcegraph/milestone/44)
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/12836  __1.00d__   🏳️ [3.20](https://github.com/sourcegraph/sourcegraph/milestone/45)
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675  __14.50d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990  __14.50d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: uwedeportivo -->
@uwedeportivo: __7.00d__


Completed: __7.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9253  __7.00d__
- [x] (🏁 577 days ago) https://github.com/sourcegraph/sourcegraph/issues/9250  __7.00d__
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/12836  __1.00d__   🏳️ [3.20](https://github.com/sourcegraph/sourcegraph/milestone/45)
- [x] (🏁 378 days ago) https://github.com/sourcegraph/sourcegraph/issues/13675  __7.00d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 354 days ago) https://github.com/sourcegraph/sourcegraph/issues/14630  __4.00d__   🏳️ [Dist: 2020.11.03](https://github.com/sourcegraph/sourcegraph/milestone/55)
- [x] (🏁 326 days ago) https://github.com/sourcegraph/sourcegraph/issues/16087  __4.00d__   🏳️ [Dist: 2020.11.30](https://github.com/sourcegraph/sourcegraph/milestone/67)
- [x] (🏁 272 days ago) https://github.com/sourcegraph/sourcegraph/issues/17990  __7.00d__
<!-- END ASSIGNEE -->
<!-- END WORK -->

#### Legend

- 👩 Customer issue
- 🐛 Bug
- 🧶 Technical debt
- 🎩 Quality of life
- 🛠️ [Roadmap](https://docs.google.com/document/d/1cBsE9801DcBF9chZyMnxRdolqM_1c2pPyGQz15QAvYI/edit#heading=h.5nwl5fv52ess)
- 🕵️ [Spike](https://en.wikipedia.org/wiki/Spike_(software_development))
- 🔒 Security issue
- :shipit: Pull Request
