### Plan

**Goal:** Get the top three most popular language indexers: lsif-go, lsif-java, lsif-clang stable by working directly on implementation with customers to identify and resolve any remaining issues that prevent the tool from being use in a wide release. This goal takes top priority for this milestone and each member of the team is leading the initiative on an indexer. 

**Goal:** Improve the reliability and the precise code intel backend by migrating data away from SQLite and into a more suitable database, Postgres.

**Goal:** Improve best effort auto-indexing for supported languages (see issues related to RFC 201).

### Availability

Period is from 2020-09-20 to 2020-10-20. Please write the days you won't be working and the number of working days for the period.

* Aida: 10d
* Eric: 19d (off 2020/09/28-30)
* Noah: 21d (off 2020/10/02)
* Garo: 10d (off 2020/10/05-09)

### Tracked issues

<!-- BEGIN WORK -->
<!-- BEGIN ASSIGNEE:  -->
@unassigned

- [ ] https://github.com/sourcegraph/sourcegraph/issues/26230 
  - [x] (🏁 160 days ago) https://github.com/sourcegraph/sourcegraph/issues/12501    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)

Completed
- [x] (🏁 387 days ago) https://github.com/sourcegraph/sourcegraph/issues/14608 (PRs: ~[#14637](https://github.com/sourcegraph/sourcegraph/pull/14637)~) 🧶   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 160 days ago) https://github.com/sourcegraph/sourcegraph/issues/12501    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: Strum355 -->
@Strum355


Completed
- [x] (🏁 407 days ago) https://github.com/sourcegraph/sourcegraph/issues/14057  🕵️   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 388 days ago) https://github.com/sourcegraph/sourcegraph/issues/14486 (PRs: ~[#14581](https://github.com/sourcegraph/sourcegraph/pull/14581)~)   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 171 days ago) https://github.com/sourcegraph/sourcegraph/issues/3418    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: aidaeology -->
@aidaeology: __1.00d__

- [ ] https://github.com/sourcegraph/sourcegraph/issues/26230  __0.50d__
  - [x] (🏁 403 days ago) https://github.com/sourcegraph/sourcegraph/issues/14224  __0.50d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)

Completed: __1.00d__
- [x] (🏁 407 days ago) https://github.com/sourcegraph/about/pull/1628 
- [x] (🏁 403 days ago) https://github.com/sourcegraph/sourcegraph/issues/14224  __0.50d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 384 days ago) https://github.com/sourcegraph/sourcegraph/issues/13200  __0.50d__ 🐛   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 156 days ago) https://github.com/sourcegraph/sourcegraph/pull/14257 🧶
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: beyang -->
@beyang: __4.00d__

- [ ] https://github.com/sourcegraph/sourcegraph/issues/26230 
  - [x] (🏁 403 days ago) https://github.com/sourcegraph/sourcegraph/pull/14211 

Completed: __4.00d__
- [x] (🏁 403 days ago) https://github.com/sourcegraph/sourcegraph/pull/14211 
- [x] (🏁 206 days ago) https://github.com/sourcegraph/sourcegraph/issues/12349  __4.00d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: efritz -->
@efritz: __6.00d__


Completed: __6.00d__
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/12930  🐛   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/13957 (PRs: ~[#14005](https://github.com/sourcegraph/sourcegraph/pull/14005)~) __0.50d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 409 days ago) https://github.com/sourcegraph/sourcegraph/issues/14008    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 408 days ago) https://github.com/sourcegraph/sourcegraph/pull/14035 
- [x] (🏁 407 days ago) https://github.com/sourcegraph/sourcegraph/pull/14060 
- [x] (🏁 406 days ago) https://github.com/sourcegraph/sourcegraph/issues/14044 (PRs: ~[#14061](https://github.com/sourcegraph/sourcegraph/pull/14061)~, ~[#14063](https://github.com/sourcegraph/sourcegraph/pull/14063)~)   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 406 days ago) https://github.com/sourcegraph/sourcegraph/pull/14124 
- [x] (🏁 399 days ago) https://github.com/sourcegraph/sourcegraph/issues/14052 (PRs: ~[#14141](https://github.com/sourcegraph/sourcegraph/pull/14141)~) 🐛   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 399 days ago) https://github.com/sourcegraph/sourcegraph/pull/14344 
- [x] (🏁 399 days ago) https://github.com/sourcegraph/sourcegraph/pull/14142 
- [x] (🏁 399 days ago) https://github.com/sourcegraph/sourcegraph/pull/14353 
- [x] (🏁 399 days ago) https://github.com/sourcegraph/sourcegraph/pull/14355 
- [x] (🏁 399 days ago) https://github.com/sourcegraph/sourcegraph/pull/14358 
- [x] (🏁 399 days ago) https://github.com/sourcegraph/sourcegraph/issues/14264    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 394 days ago) https://github.com/sourcegraph/sourcegraph/pull/14428 
- [x] (🏁 394 days ago) https://github.com/sourcegraph/sourcegraph/issues/14467 (PRs: ~[#14469](https://github.com/sourcegraph/sourcegraph/pull/14469)~)   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 392 days ago) https://github.com/sourcegraph/sourcegraph/pull/14491 
- [x] (🏁 388 days ago) https://github.com/sourcegraph/sourcegraph/issues/14486 (PRs: ~[#14581](https://github.com/sourcegraph/sourcegraph/pull/14581)~)   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 388 days ago) https://github.com/sourcegraph/sourcegraph/pull/14648 
- [x] (🏁 387 days ago) https://github.com/sourcegraph/sourcegraph/pull/14633 
- [x] (🏁 387 days ago) https://github.com/sourcegraph/sourcegraph/pull/14637 
- [x] (🏁 387 days ago) https://github.com/sourcegraph/sourcegraph/pull/14624 
- [x] (🏁 387 days ago) https://github.com/sourcegraph/sourcegraph/pull/14677 
- [x] (🏁 386 days ago) https://github.com/sourcegraph/sourcegraph/pull/14695 
- [x] (🏁 386 days ago) https://github.com/sourcegraph/sourcegraph/pull/14721 
- [x] (🏁 386 days ago) https://github.com/sourcegraph/sourcegraph/pull/14722 
- [x] (🏁 386 days ago) https://github.com/sourcegraph/sourcegraph/pull/14733 
- [x] (🏁 370 days ago) https://github.com/sourcegraph/sourcegraph/pull/14679 
- [x] (🏁 359 days ago) https://github.com/sourcegraph/sourcegraph/issues/13733    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 351 days ago) https://github.com/sourcegraph/sourcegraph/issues/13891  __1.00d__
- [x] (🏁 279 days ago) https://github.com/sourcegraph/sourcegraph/issues/13882  __4.50d__
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: macraig -->
@macraig: __0.50d__

- [ ] ~https://github.com/sourcegraph/sourcegraph/issues/13015~    🏳️ [Backlog](https://github.com/sourcegraph/sourcegraph/milestone/5)

Completed: __0.50d__
- [x] (🏁 394 days ago) https://github.com/sourcegraph/sourcegraph/issues/14348    🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 384 days ago) https://github.com/sourcegraph/sourcegraph/issues/13200  __0.50d__ 🐛   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
<!-- END ASSIGNEE -->

<!-- BEGIN ASSIGNEE: shrouxm -->
@shrouxm: __5.00d__


Completed: __5.00d__
- [x] (🏁 399 days ago) https://github.com/sourcegraph/lsif-clang/issues/15    🏳️ [3.21](https://github.com/sourcegraph/lsif-clang/milestone/4)
- [x] (🏁 399 days ago) https://github.com/sourcegraph/lsif-clang/issues/3  🐛   🏳️ [3.21](https://github.com/sourcegraph/lsif-clang/milestone/4)
- [x] (🏁 381 days ago) https://github.com/sourcegraph/sourcegraph/issues/13202  __1.00d__ 🕵️   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
- [x] (🏁 381 days ago) https://github.com/sourcegraph/lsif-clang/issues/13  🐛   🏳️ [3.21](https://github.com/sourcegraph/lsif-clang/milestone/4)
- [x] (🏁 206 days ago) https://github.com/sourcegraph/sourcegraph/issues/12349  __4.00d__   🏳️ [3.21](https://github.com/sourcegraph/sourcegraph/milestone/46)
<!-- END ASSIGNEE -->
<!-- END WORK -->

#### Legend

- 👩 Customer issue
- 🐛 Bug
- 🧶 Technical debt
- 🎩 Quality of life
- 🛠️ [Roadmap](https://docs.google.com/document/d/1cBsE9801DcBF9chZyMnxRdolqM_1c2pPyGQz15QAvYI/edit#heading=h.5nwl5fv52ess)
- 🕵️ [Spike](https://en.wikipedia.org/wiki/Spike_(software_development))
- 🔒 Security issue
- :shipit: Pull Request
